/*
 * Copyright 2016 The Closure Rules Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.google.javascript.jscomp;

final class JsCheckerClosureCodingConvention extends CodingConventions.Proxy {

  private static final long serialVersionUID = 1L;

  JsCheckerClosureCodingConvention() {
    super(new ClosureCodingConvention());
  }

  @Override
  public boolean isPrivate(String name) {
    return name.endsWith("_");
  }
}
